#############################################################################################
# PoD-Reserveslots																			#
# Version: 			v1.0 [Date: 31.10.2012]													#
# Written by:																				#
#					TheSpeedFreak (Steam)													#
#					SpeedFreak (Eventscripts Forum)											#
#																							#
# Special Thanks to:																		#
#					Mattie:				Eventscripts Plugin									#
#																							#
# Website: 			www.NextGenerationGaming.de												#
# Description: 		Mod to enable reserved slots for admins or other players.				#
#############################################################################################

import es
import gamethread
import playerlib
import popuplib

#Globals
pathUsers = es.getAddonPath("pod_reserveslots")+'/configs/reserveslots.txt'

#Lists
adminList = []
cmdList = ['!reserve','reserve','!reserveslot','reserveslot','!reserveslots','reserveslots']

#Dicts
users = {}

#Info
info = es.AddonInfo() 
info.name     	= 'PoD-Reserveslots' 
info.basename 	= 'pod_reserveslots'
info.version  	= es.ServerVar('pod_reserveslots_version')
info.url      	= 'http://addons.eventscripts.com/addons/view/PoD-Reserveslots' 
info.description = 'Mod to enable reserved slots for admins.'
info.author   	= 'Steam: TheSpeedFreak | Eventscripts Forum: SpeedFreak'

def load():
	global pod_reserveslots_main
	es.set('pod_reserveslots_version', 'v1.0')
	es.makepublic('pod_reserveslots_version')
	es.set('pod_reserveslots_admins',"")
	es.set('pod_reserveslots_mode',2)
	es.set('pod_reserveslots_max',2)
	es.set('pod_reserveslots_kickbots',1)
	es.set('pod_reserveslots_kickmsg','Sorry, reserved slot!')
	es.set('pod_reserveslots_show_kickmsg',1)
	es.server.queuecmd('es_xmexec ../addons/eventscripts/pod_reserveslots/configs/config.cfg')
	for CMD in cmdList: es.regsaycmd(CMD,'pod_reserveslots/popupOpen','Open Reserveslot-Popup')
	file = open(pathUsers,'r')
	content = file.readlines()
	file.close()
	line = -1
	for x in content:
		line += 1
		x = x.rstrip('\n')
		if x.startswith('STEAM_'):
			pos = x.find('|')
			if pos != -1:
				steamid = x[0:pos]
				if len(x)- len(x[0:pos+1]) > 1:
					name = x[pos+1:len(x)]
				else:
					name = "Unknown Player" 
			else:
				steamid = x
				name = "Unknown Player"
			if steamid not in users: users[steamid] = name
	pod_reserveslots_main = popuplib.easymenu('pod_reserveslots_main',None,popupOutput)
	pod_reserveslots_main.settitle('PoD-Reserveslots')
	pod_reserveslots_main.addoption('add','Add User')
	pod_reserveslots_main.addoption('remove','Remove User\n-----------------------------')
	pod_reserveslots_main.addoption('about','About')
	gamethread.delayed(1,setVars)

def unload():
	global pod_reserveslots_main
	for CMD in cmdList: es.unregsaycmd(CMD)
	pod_reserveslots_main.delete()
	for userid in es.getUseridList(): whisper(userid,'%s #greensuccessfully unloaded!' % es.ServerVar('pod_reserveslots_version'))

def player_activate(ev):
	userid = int(ev['userid'])
	name = ev['es_username']
	steamid = ev['es_steamid']
	pcount = es.getplayercount()
	maxslots = es.getmaxplayercount()
	if es.ServerVar('pod_reserveslots_mode') == 1:
		reserveslotsMax = es.ServerVar('pod_reserveslots_max')
		maxslots -= reserveslotsMax
		if pcount > maxslots:
			reserveslotsUsed = 0
			for user in es.getUseridList():
				if es.getplayersteamid(user) in users:
					if reserveslotsUsed < reserveslotsMax: reserveslotsUsed += 1
			if pcount-reserveslotsUsed > maxslots: kick(userid,name)
	elif es.ServerVar('pod_reserveslots_mode') == 2:
		if pcount == maxslots:
			plist = []
			for player in playerlib.getPlayerList():
				if (player.steamid != 'BOT' and player.steamid not in users) or (player.steamid == 'BOT' and es.ServerVar('pod_reserveslots_kickbots')): plist.append((int(player.timeconnected),player.name,player.userid))
			if len(plist) > 0:
				templist = sorted(plist, key = lambda connected: connected[0])
				kick(templist[0][2],templist[0][1])

def setVars():
	global adminList
	if es.ServerVar("pod_reserveslots_admins") != "" or es.ServerVar("pod_reserveslots_admins") != '': adminList = str(es.ServerVar("pod_reserveslots_admins")).split(';')
	for userid in es.getUseridList(): whisper(userid,'%s #greensuccessfully loaded!' % es.ServerVar('pod_reserveslots_version'))

def addUser(steamid,name):
	if steamid not in users:
		users[steamid] = name
		file = open(pathUsers,'a')
		file.write('\n%s|%s' % (steamid,name))
		file.close()

def kick(userid,name):
	es.server.queuecmd('kickid %s %s' % (userid,es.ServerVar('pod_reserveslots_kickmsg')))
	if es.ServerVar('pod_reserveslots_show_kickmsg'):
		for userid in es.getUseridList(): whisper(userid,'#greenKicked: \x0720B2AA%s' % name)

def popupOpen():
	userid = es.getcmduserid()
	steamid = es.getplayersteamid(userid)
	if steamid in adminList:
		popupCreate(userid,1)
		playSound(userid,1)
	else:
		whisper(userid,'#greenYou have no access to this command!')
		playSound(userid,0)

def popupCreate(userid,popupID):
	#1 = Main
	#2 = Add Player
	#3 = Remove Player
	if popupID == 1:
		pod_reserveslots_main.send(userid)
	elif popupID == 2:
		temp = popuplib.easymenu('pod_reserveslots_add',None,popupOutput)
		temp.settitle('PoD-Reserveslots')
		temp.setdescription('[Add User]')
		for user in es.getUseridList():
			name = es.getplayername(user)
			steamid = es.getplayersteamid(user)
			if steamid not in users and steamid != 'BOT': temp.addoption(steamid,'%s [%s]' % (name,steamid))
		temp.submenu(10,pod_reserveslots_main)
		temp.send(userid)
		temp.delete()
	elif popupID == 3:
		temp = popuplib.easymenu('pod_reserveslots_remove',None,popupOutput)
		temp.settitle('PoD-Reserveslots')
		temp.setdescription('[Remove User]')
		for player in users: temp.addoption(player,'%s [%s]' % (users[player],player))
		temp.submenu(10,pod_reserveslots_main)
		temp.send(userid)
		temp.delete()

def popupOutput(userid,choice,popupname):
	if popupname == 'pod_reserveslots_main':
		if choice == 'add':
			popupCreate(userid,2)
			playSound(userid,1)
		elif choice == 'remove':
			if len(users) > 0:
				popupCreate(userid,3)
				playSound(userid,1)
			else:
				popupCreate(userid,1)
				whisper(userid,'#greenNobody owns a reserved slot!')
				playSound(userid,0)
		elif choice == 'about':
			temp = popuplib.create('pod_reserveslots_about')
			temp.addline('Name: PoD-Reserveslots')
			temp.addline('Version: %s' % es.ServerVar('pod_reserveslots_version'))
			temp.addline('Written by: TheSpeedFreak')
			temp.addline('Website: www.NextGenerationGaming.de')
			temp.addline(' ')
			temp.addline('Description:')
			temp.addline('Mod to enable reserved slots for admins.')
			for i in xrange(1,11): temp.submenu(i,pod_reserveslots_main)
			temp.send(userid)
			temp.delete()
			playSound(userid,1)
	elif popupname == 'pod_reserveslots_add':
		if choice not in users:
			newUser = es.getuserid(choice)
			if newUser:
				name = es.getplayername(newUser)
			else:
				name = "Unknown Player"
			addUser(choice,name)
			whisper(userid,'#greenAdded: \x0720B2AA%s' % choice)
			playSound(userid,1)
			popupCreate(userid,2)
		else:
			whisper(userid,'#greenError: \x0720B2AA%s #greenowns a reserved slot already!' % choice)
			playSound(userid,0)
			popupCreate(userid,2)
	elif popupname == 'pod_reserveslots_remove':
		entry = 0
		temp = []
		file = open(pathUsers,'r')
		content = file.readlines()
		file.close()
		for x in content:
			if x == choice or x == choice+'\n' or x.startswith(choice+'|'):
				entry = 1
			else:
				temp.append(x)
		if entry:
			temp[len(temp)-1] = temp[len(temp)-1].rstrip('\n')
			file = open(pathUsers,'w')
			file.writelines(temp)
			file.close()
			whisper(userid,'#greenRemoved: \x0720B2AA%s' % choice)
			del users[choice]
			playSound(userid,1)
		else:
			whisper(userid,'#greenError: \x0720B2AA%s #greennot found!' % choice)
			if choice in users: del users[choice]
			playSound(userid,0)
		if len(users) > 0:
			popupCreate(userid,3)
		else:
			pod_reserveslots_main.send(userid)

def whisper(userid,msg):
	es.tell(userid,'#multi','\x07000000[\x0720B2AAPoD-Reserveslots\x07000000] \x0720B2AA%s' % str(msg))

def playSound(userid,number):
	#0 = Denied
	#1 = Access
	if number == 0: es.playsound(userid,'buttons/button11.wav',1.0)
	if number == 1: es.playsound(userid,'UI/buttonclick.wav',1.0)